/*
   NTEST.C - Sample program for NAPI.DLL
   Copyright (c) 1995 Sangoma Technologies Inc.
   Author: Glenn Robins
   November 1995

   Use at your own risk.
   Build:
        (Static) runtime library only, plus NAPI.LIB or NAPI32.LIB
	Windows 16-bit .EXE, Large Model
	or Win32 GUI

*/

/* for "portability" to Win32 in case we want to */
#define STRICT

/*
#define MAKEFORNT
*/

#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#ifdef MAKEFORNT
#include "k:\apidev\napi32mc\napi32mc.h"
#else
#include "d:\napi\napi_f.h"
#endif
#include "d:\napi\napi_m.h"


#define SAYRESPONSE(s)	SetDlgItemText(exehwn, 900, s)
#define	SAYSTATE(x)	SetWindowText(exehwn, x)
#define	SAYNOSTATE()	SetWindowText(exehwn, szProgramHeader)

#define	IDM_ABOUT	0x1000

HINSTANCE ghinstance;
HWND exehwn;

CBLOCK cb;

char txtext[1000];

char *our_ini_file = "ntest.ini";
char *iniHardwareSection = "Hardware";
char *iniCardEntry = "default_card_number";
char *iniAskEntry = "ask_for_card_on_startup";

char *szhigh = "HIGH";
char *szlow = "LOW";

#ifdef MAKEFORNT
char *abouttitle = "About The NTESTer v1.0nt";
char *aboutstatement =
"NTEST for NT - BSCV2 Tester\nCopyright (c) 1996 Sangoma Technologies Inc.\nJune 1996 release";
#else
char *abouttitle = "About The NTESTer v1.0";
char *aboutstatement =
"NTEST - BSCV2 Tester\nCopyright (c) 1996 Sangoma Technologies Inc.\nJune 1996 release";
#endif
char szProgramHeader[40];
BYTE card = 0;
BYTE askonstartup = 0;

char *szTitleName = "Basic Functions BSC Tester";

/* prototypes */
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow);
LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam );
LRESULT CALLBACK _export SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam);
void DoCommand(void);
BOOL FirstSelCard(void);
BOOL ParseCmdLineForCard(LPSTR lpszCmdLine);
int ParseTextToHex(int l);
void SelCard(void);

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	MSG msg;
	BOOL fRetVal;
	WNDCLASS wndclass;
	HMENU hmenu;
	char s[120];

	ghinstance = hInstance;

	card = (BYTE)GetPrivateProfileInt(iniHardwareSection, iniCardEntry, 0, our_ini_file);
	askonstartup = (BYTE)GetPrivateProfileInt(iniHardwareSection, iniAskEntry, 0, our_ini_file);

	if (hPrevInstance == NULL) {

		/* set up and register the window class */
		wndclass.style         = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc   = MainWndProc;
		wndclass.cbClsExtra    = 0;
		wndclass.cbWndExtra    = DLGWINDOWEXTRA;
		wndclass.hInstance     = ghinstance;
		wndclass.hIcon         = LoadIcon(ghinstance, "tester");
		wndclass.hCursor       = LoadCursor(NULL, IDC_ARROW);
		wndclass.hbrBackground = (HBRUSH)GetStockObject(GRAY_BRUSH);
		wndclass.lpszMenuName  = NULL;
		wndclass.lpszClassName = "NTEST";

		if (!RegisterClass(&wndclass)) {
			return(0);
		}

	} // end instance check

	// must tell NAPI to initialize SDLA driver if we are first
	NAPISetup();

	exehwn = CreateDialog(ghinstance, "MAINDLG", HWND_DESKTOP, NULL);

	if (!exehwn)  return(0);	/* failed to create window */

	// see if user wants to override startup card
	if (!ParseCmdLineForCard(lpszCmdLine)) {
		if (askonstartup) {
			if (!FirstSelCard()) {
				DestroyWindow(exehwn);
				return(0);
			}
		}
	}

	// must register for the use of 'card' before we can use it
	if (!NAPIRegisterCard(card)) {
		sprintf(s, "Unable to register card %u!  NTEST will now terminate.  (Default card number may be changed by editing NTEST.INI.)", card);
		MessageBox(exehwn, s, "NTEST FATAL ERROR", MB_OK | MB_ICONHAND);
		DestroyWindow(exehwn);
		return(0);
	}

	hmenu = GetSystemMenu(exehwn, FALSE);
	AppendMenu(hmenu, MF_SEPARATOR, 0, (LPSTR) NULL);
	AppendMenu(hmenu, MF_STRING, IDM_ABOUT, "About...");

	sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
	SAYNOSTATE();

	// set default values in window
	SetDlgItemText(exehwn, 910, "00");
	SetDlgItemText(exehwn, 911, "00");
	CheckDlgButton(exehwn, 400, 1);
	CheckDlgButton(exehwn, 401, 1);
	CheckDlgButton(exehwn, 301, 1);


	fRetVal = TRUE;		/* keep looping until FALSE (WM_QUIT) */

	/* stay in this outside loop until the WM_QUIT message has
	been encountered and processed */
	while (fRetVal)  {
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
			if (msg.message == WM_QUIT)
				fRetVal = FALSE;	/* leave main loop */
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	// clean things up - VERY IMPORTANT!!!
	NAPIDeregisterCard(card);
	NAPICleanup();
	return fRetVal;
}

BOOL ParseCmdLineForCard(LPSTR lpszCmdLine)
{
	int i;
	BYTE c;

	i=0;
	while (lpszCmdLine[i] != NULL && lpszCmdLine[i] != '-') i++;
	if (lpszCmdLine[i] == '-') {
		c = (BYTE)atoi((LPSTR)(lpszCmdLine+i+1));
		if (c < 16) {
			card = c;
			return(TRUE);
		}
	}
	return(FALSE);
}

BOOL FirstSelCard(void)
{
	DLGPROC dproc;
	int i;

	dproc = (DLGPROC)MakeProcInstance((FARPROC)SelCardDlg, ghinstance);
	i=DialogBox(ghinstance, "SELCARD", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
	if (i) {
		card = i-1;
		return(TRUE);
	}
	return(FALSE);
}

void SelCard(void)
{
	DLGPROC dproc;
	int i;
//	char s[80];

	dproc = (DLGPROC)MakeProcInstance((FARPROC)SelCardDlg, ghinstance);
	i=DialogBox(ghinstance, "SELCARD", exehwn, dproc);
	FreeProcInstance((FARPROC)dproc);
	if (i) {
		if (NAPIRegisterCard(i-1)) {
			NAPIDeregisterCard(card);
			card = i-1;
			sprintf(szProgramHeader, "%s (Card %u)", szTitleName, card);
			SAYNOSTATE();
		}
		else {
			MessageBox(exehwn, "Unable to register specified card!", "NTEST FATAL ERROR", MB_OK | MB_ICONHAND);
		}
	}
}

/* main window procedure */
LRESULT CALLBACK _export MainWndProc(HWND hWnd, UINT iMessage, WPARAM wParam, LPARAM lParam )
{
	WORD v, i;
	char s[5];

	switch(iMessage) {
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 100:	// Exit button
			DestroyWindow(hWnd);
			PostQuitMessage(0);
			return(0);
		case 101:	// Select card button
			SelCard();
			return(0);
		case 200:	// BSC_OPEN
			cb.command = OPEN_LINK;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 201:	// BSC_CLOSE
			cb.command = CLOSE_LINK;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 202:	// READ_MODEM_STATUS
			cb.command = READ_MODEM_STATUS;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 203:	// MODEM CONTROL
			cb.command = SET_MODEM_STATUS;
			cb.buffer_length = 1;
			cb.data[0] = (IsDlgButtonChecked(exehwn, 400)) ? 0x01 : 0x00;
			cb.data[0] |= (IsDlgButtonChecked(exehwn, 401)) ? 0x02 : 0x00;
			DoCommand();
			return(0);
		case 220:	// LIST_ACTIVE_STATIONS
			cb.command = LIST_STATIONS;
			cb.buffer_length = 0;
			DoCommand();
			return(0);
		case 221:	// ADD_STATION
			cb.command = ADD_STATION;
			cb.buffer_length = 3;
			GetDlgItemText(exehwn, 902, s, 3);
			sscanf(s, "%2x", &v);
			cb.poll_address = (BYTE)v;
			GetDlgItemText(exehwn, 903, s, 3);
			sscanf(s, "%2x", &v);
			cb.select_address = (BYTE)v;
			GetDlgItemText(exehwn, 904, s, 3);
			sscanf(s, "%2x", &v);
			cb.device_address = (BYTE)v;
			cb.data[0] = 0;		// no queue limit for tx
			cb.data[1] = 0;		// no queue limit for rx
			cb.data[2] = 0x80;	// enabled
			DoCommand();
			// automatically update the station number fields
			if (cb.return_code == 0) {
				sprintf(s, "%02X", (BYTE)cb.station);
				SetDlgItemText(exehwn, 910, s);
				SetDlgItemText(exehwn, 911, s);
			}
			return(0);
		case 210:	// BSC_READ
			cb.command = BSC_READ;
			cb.buffer_length = 0;
			GetDlgItemText(exehwn, 910, s, 3);
			sscanf(s, "%2x", &v);
			cb.station = (BYTE)v;
			DoCommand();
			return(0);
		case 211:	// BSC_WRITE
			cb.command = BSC_WRITE;
			v = GetDlgItemText(exehwn, 901, txtext, 1000);
			v = ParseTextToHex(v);
			cb.buffer_length = v;
			GetDlgItemText(exehwn, 911, s, 3);
			sscanf(s, "%2x", &v);
			cb.station = (BYTE)v;
			cb.misc_tx_rx_bits = 0;
			cb.misc_tx_rx_bits |= (IsDlgButtonChecked(exehwn, 300)) ? 0x01 : 0x00;
			cb.misc_tx_rx_bits |= (IsDlgButtonChecked(exehwn, 302)) ? 0x02 : 0x00;
			cb.misc_tx_rx_bits |= (IsDlgButtonChecked(exehwn, 303)) ? 0x04 : 0x00;
			DoCommand();
			return(0);
		case 212:	// BSC_WRITE repeated constant
			cb.command = BSC_WRITE;
			cb.buffer_length = (WORD)GetDlgItemInt(exehwn, 913, NULL, FALSE);
			if (cb.buffer_length > MDATALEN) {
				SAYRESPONSE("Length of string to write is too large to fit in mailbox - must be between 1 and 4000");
				return(0);
			}
			GetDlgItemText(exehwn, 911, s, 3);
			sscanf(s, "%2x", &v);
			cb.station = (BYTE)v;
			cb.misc_tx_rx_bits = 0;
			cb.misc_tx_rx_bits |= (IsDlgButtonChecked(exehwn, 300)) ? 0x01 : 0x00;
			cb.misc_tx_rx_bits |= (IsDlgButtonChecked(exehwn, 302)) ? 0x02 : 0x00;
			cb.misc_tx_rx_bits |= (IsDlgButtonChecked(exehwn, 303)) ? 0x04 : 0x00;
			GetDlgItemText(exehwn, 912, s, 3);
			sscanf(s, "%2x", &v);
			for (i=0; i < cb.buffer_length; i++) cb.data[i] = v;
			DoCommand();
			return(0);
		}
		break;

	case WM_SYSCOMMAND:
		if (wParam == SC_CLOSE) {
			DestroyWindow(hWnd);
			PostQuitMessage(0);
			return(0);
		}
		if (GET_WM_COMMAND_ID(wParam, lParam) == IDM_ABOUT) {
			MessageBox(exehwn, aboutstatement, abouttitle, MB_OK | MB_ICONINFORMATION);
			return(0);
		}
		break;
	}
	return DefDlgProc( hWnd, iMessage, wParam, lParam );
}

void DoCommand(void)
{
	char s[150], s1[150];
	WORD i;

	NAPIControl(&cb, card);
	sprintf(s, "Return code: 0x%02X - ", (BYTE)cb.return_code);
	switch(cb.return_code) {
	case 0x00:
		switch(cb.command) {
		case READ_MODEM_STATUS:
			sprintf(s1, "CTS is %s and DCD is %s", (cb.data[0] & 0x20) ? szhigh : szlow, (cb.data[0] & 0x08) ? szhigh : szlow);
			strcat(s, s1);
			break;
		case LIST_STATIONS:
			if (cb.buffer_length) {
				for (i=0; i < cb.buffer_length/10; i++) {
					if (i > 18) { strcat(s, "..."); break; }
					if ((cb.data[i*10+1] & 0x01)) {
						sprintf(s1, "%02X ", (BYTE)cb.data[i*10]);
						strcat(s, s1);
					}
				}
			} else strcat(s, "None");
			break;
		case ADD_STATION:
			sprintf(s1, "Successfully added station number %02X (hex)", (BYTE)cb.station);
			strcat(s, s1);
			break;
		case BSC_READ:
			sprintf(s1, "%u bytes (%s", cb.buffer_length, (cb.misc_tx_rx_bits & 0x01) ? "Transp " : "");
			strcat(s, s1);
			if (cb.misc_tx_rx_bits & 0x02) strcat(s, "ETB");
			else if (cb.misc_tx_rx_bits & 0x04) strcat(s, "ITB");
			else strcat(s, "ETX");
			strcat(s, "): ");
			for (i=0; i < cb.buffer_length; i++) {
				if (i > 18) {
					strcat(s, "...");
					break;
				}
				sprintf(s1, "%02X ", (BYTE)cb.data[i]);
				strcat(s, s1);
			}
			break;
		default:
			strcat(s, "The action was performed successfully");
		}
		break;
	case 0x0a:
		strcat(s, "Hardware timeout error");
		break;
	default:
		// command not successful messages
		switch(cb.command) {
		case OPEN_LINK:
			strcat(s, "The device is already open");
			break;
		case CLOSE_LINK:
			strcat(s, "The device is already closed");
			break;
		case ADD_STATION:
			switch(cb.return_code) {
			case 0x02:
				strcat(s, "The station had already been added");
				break;
			case 0x07:
				strcat(s, "The maximum of 32 stations has been reached");
				break;
			}
			break;
		case BSC_READ:
			switch(cb.return_code) {
			case 0x01:
				strcat(s, "No text message available at this station");
				break;
			case 0x04:
				strcat(s, "The device is closed");
				break;
			case 0x05:
				strcat(s, "Station in circuit assurance mode");
				break;
			case 0x07:
				strcat(s, "Invalid station number");
				sprintf(s1, " (%02X)", (BYTE)cb.station);
				strcat(s, s1);
				break;
			}
			break;
		case BSC_WRITE:
			switch(cb.return_code) {
			case 0x02:
				strcat(s, "Transmit buffers are full");
				break;
			case 0x04:
				strcat(s, "The device is closed");
				break;
			case 0x05:
				strcat(s, "Station in circuit assurance mode");
				break;
			case 0x03:
				strcat(s, "Length of text message too long after formatting");
				break;
			case 0x07:
				strcat(s, "Invalid station number");
				sprintf(s1, " (%02X)", (BYTE)cb.station);
				strcat(s, s1);
				break;
			case 0x06:
				strcat(s, "Station is currently inactive");
				sprintf(s1, " (%02X)", (BYTE)cb.station);
				strcat(s, s1);
				break;
			}
			break;
		}
	}
	SAYRESPONSE(s);
}

LRESULT CALLBACK _export SelCardDlg(HWND hDlg, UINT iMessage, WPARAM wParam, LPARAM lParam)
{
	int n, m, default_card;
	LRESULT c;
	char s[5];
	static int ncard;

	switch(iMessage) {
	case WM_SYSCOMMAND:
		switch(wParam & 0xfff0) {
		case SC_CLOSE:	/* Don't allow user to close window this way */
			return(1);
		}
		break;
	case WM_INITDIALOG:
		c = NAPIGetCards(); m = 0;
		ncard = (int)card;
		for (n=0; n < 16; n++) {
			if (c & (1L << (16+n))) {
				sprintf(s, "%2d", n);
				SendDlgItemMessage(hDlg, 101, CB_ADDSTRING, 0, (LPARAM)s);
				if (ncard == n)
					SendDlgItemMessage(hDlg, 101, CB_SETCURSEL, m, 0);
				m++;
			}
		}
		default_card = GetPrivateProfileInt(iniHardwareSection, iniCardEntry, 0, our_ini_file);
		sprintf(s, "%u", (UINT)default_card);
		SetDlgItemText(hDlg, 103, s);
		CheckDlgButton(hDlg, 104, askonstartup);
		return(1L);
	case WM_COMMAND:
		switch(GET_WM_COMMAND_ID(wParam, lParam)) {
		case 101:
			if (GET_WM_COMMAND_CMD(wParam, lParam) == CBN_SELENDOK) {
				SendDlgItemMessage(hDlg, 101, CB_GETLBTEXT, (WPARAM)SendDlgItemMessage(hDlg, 101, CB_GETCURSEL, 0, 0), (LPARAM)s);
				ncard = atoi(s);
			}
			break;
		case IDOK:
			if (IsDlgButtonChecked(hDlg, 102)) {
				sprintf(s, "%u", (UINT)ncard);
				WritePrivateProfileString(iniHardwareSection, iniCardEntry, s, our_ini_file);
			}
			if (IsDlgButtonChecked(hDlg, 104)) strcpy(s, "1");
			else strcpy(s, "0");
			if (askonstartup != (s[0]-'0'))  {
				WritePrivateProfileString(iniHardwareSection, iniAskEntry, s, our_ini_file);
				askonstartup = (s[0]-'0');
			}
			EndDialog(hDlg, ncard+1);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			break;
		}
	}
	return(0);
}

int ParseTextToHex(int l)
{
	int i, j;
	WORD v;

	i=0; j=0;
	while (i < l) {
		sscanf(&txtext[i], "%2x", &v);
		cb.data[j] = (BYTE)v;
		j++;
		while (i < l && txtext[i] != ' ') i++;
		i++;
	}
	return(j);
}

